import type { PriorityQueueInstance, PriorityQueueOption } from "./PriorityQueue";
import { BasePriorityQueue } from "./PriorityQueue";
import type { Comparator } from "./comparator";
declare type Node<T> = {
    value: T;
    nextSibling: Node<T> | null;
    firstChild: Node<T> | null;
};
export default class PairingHeap<T> extends BasePriorityQueue implements PriorityQueueInstance<T> {
    comparator: Comparator<T>;
    root: Node<T> | null;
    _length: number;
    static from<U>(array: U[], option?: PriorityQueueOption<U>): PairingHeap<U>;
    constructor({ comparator }?: PriorityQueueOption<T>);
    clear(): void;
    get length(): number;
    push(val: T): void;
    top(): T;
    pop(): T;
    merge<Instance extends PriorityQueueInstance<T>>(other: Instance): void;
    toArray(): T[];
    isEmpty(): boolean;
}
export {};
